#include "hal_data.h"
#include <stdio.h>
#include "Digital_Light_ISL29035.h"
#include "oled.h"
#include "bmp.h"
//记帖交流Q群：615061293

FSP_CPP_HEADER
void R_BSP_WarmStart(bsp_warm_start_event_t event);
FSP_CPP_FOOTER





fsp_err_t err = FSP_SUCCESS;
volatile bool uart_send_complete_flag = false;
/* Callback function */
void user_uart_callback(uart_callback_args_t *p_args)
{
    /* TODO: add your own code here */
    if(p_args->event == UART_EVENT_TX_COMPLETE)
     {
         uart_send_complete_flag = true;
     }



}


#ifdef __GNUC__                                 //串口重定向
    #define PUTCHAR_PROTOTYPE int __io_putchar(int ch)
#else
    #define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)
#endif

PUTCHAR_PROTOTYPE
{
        err = R_SCI_UART_Write(&g_uart9_ctrl, (uint8_t *)&ch, 1);
        if(FSP_SUCCESS != err) __BKPT();
        while(uart_send_complete_flag == false){}
        uart_send_complete_flag = false;
        return ch;
}

int _write(int fd,char *pBuffer,int size)
{
    for(int i=0;i<size;i++)
    {
        __io_putchar(*pBuffer++);
    }
    return size;
}





/* Callback function */
i2c_master_event_t i2c_event = I2C_MASTER_EVENT_ABORTED;
void sci_i2c_master_callback(i2c_master_callback_args_t *p_args)
{
    i2c_event = I2C_MASTER_EVENT_ABORTED;
    if (NULL != p_args)
    {
        /* capture callback event for validating the i2c transfer event*/
        i2c_event = p_args->event;
    }
}




/* Callback function */
i2c_master_event_t i2c_event1 = I2C_MASTER_EVENT_ABORTED;
void sci_i2c_master_callback0(i2c_master_callback_args_t *p_args)
{
    /* TODO: add your own code here */
    i2c_event1 = I2C_MASTER_EVENT_ABORTED;
    if (NULL != p_args)
    {
        /* capture callback event for validating the i2c transfer event*/
        i2c_event1 = p_args->event;
    }
}










uint32_t  timeout_ms = 100000;
uint32_t  timeout_ms1 = 100000;
uint32_t lux =0;




/*******************************************************************************************************************//**
 * main() is generated by the RA Configuration editor and is used to generate threads if an RTOS is used.  This function
 * is called by main() when no RTOS is used.
 **********************************************************************************************************************/
void hal_entry(void)
{
    /* TODO: add your own code here */


    /* Initialize the I2C module */
    err = R_SCI_I2C_Open(&g_i2c3_ctrl, &g_i2c3_cfg);
    /* Handle any errors. This function should be defined by the user. */
    assert(FSP_SUCCESS == err);



    /* Open the transfer instance with initial configuration. */
        fsp_err_t err = R_SCI_UART_Open(&g_uart9_ctrl, &g_uart9_cfg);
        assert(FSP_SUCCESS == err);

        printf("hello world!\n");
        /* Initialize the I2C module */
        err = R_SCI_I2C_Open(&g_i2c0_ctrl, &g_i2c0_cfg);
        /* Handle any errors. This function should be defined by the user. */
        assert(FSP_SUCCESS == err);


        DigitalLightISL29035_init();
        R_BSP_SoftwareDelay(500U, BSP_DELAY_UNITS_MILLISECONDS);
        lux = DigitalLightISL29035_readIRLux();
        printf("lux=%d\n",lux);




        OLED_Init();            //初始化OLED
        OLED_Clear()    ;
        OLED_ShowCHinese(0,0,0);//记
        OLED_ShowCHinese(16,0,1);//帖
        OLED_ShowString(0,2,"Lux:",16);
        OLED_ShowNum(32,2,lux,3,16);

//
//        OLED_ShowNum(0,2,2023,4,16);//显示ASCII字符的码值
//        OLED_ShowCHinese(32,2,2);//中文字->年
//        OLED_ShowNum(48,2,1,2,16);//显示ASCII字符的码值
//        OLED_ShowCHinese(64,2,3);//中文字->月
//        OLED_ShowNum(80,2,31,2,16);//显示ASCII字符的码值
//        OLED_ShowCHinese(96,2,4);//中文字->日
//        OLED_ShowString(0,4,"ZXY",12);
//        OLED_ShowString(0,6,"RA4M2",16);

        /* Wait for minimum time required between transfers. */
        R_BSP_SoftwareDelay(2, BSP_DELAY_UNITS_SECONDS);






        while(1)
        {

            OLED_Clear()    ;
            OLED_ShowCHinese(0,0,0);//记
            OLED_ShowCHinese(16,0,1);//帖
            OLED_ShowString(0,2,"Lux:",16);
            lux = DigitalLightISL29035_readIRLux();
            if(lux<10)
                OLED_ShowNum(32,2,lux,1,16);
            else if(lux>=10&&lux<100)
                OLED_ShowNum(32,2,lux,2,16);
            else if(lux>=100&&lux<1000)
                OLED_ShowNum(32,2,lux,3,16);
            else if(lux>=1000&&lux<10000)
                OLED_ShowNum(32,2,lux,4,16);
            printf("lux=%d\n",lux);
            R_BSP_SoftwareDelay(1000U, BSP_DELAY_UNITS_MILLISECONDS);


        }
#if BSP_TZ_SECURE_BUILD
    /* Enter non-secure code */
    R_BSP_NonSecureEnter();
#endif
}

/*******************************************************************************************************************//**
 * This function is called at various points during the startup process.  This implementation uses the event that is
 * called right before main() to set up the pins.
 *
 * @param[in]  event    Where at in the start up process the code is currently at
 **********************************************************************************************************************/
void R_BSP_WarmStart(bsp_warm_start_event_t event)
{
    if (BSP_WARM_START_RESET == event)
    {
#if BSP_FEATURE_FLASH_LP_VERSION != 0

        /* Enable reading from data flash. */
        R_FACI_LP->DFLCTL = 1U;

        /* Would normally have to wait tDSTOP(6us) for data flash recovery. Placing the enable here, before clock and
         * C runtime initialization, should negate the need for a delay since the initialization will typically take more than 6us. */
#endif
    }

    if (BSP_WARM_START_POST_C == event)
    {
        /* C runtime environment and system clocks are setup. */

        /* Configure pins. */
        R_IOPORT_Open (&g_ioport_ctrl, g_ioport.p_cfg);
    }
}

#if BSP_TZ_SECURE_BUILD

BSP_CMSE_NONSECURE_ENTRY void template_nonsecure_callable ();

/* Trustzone Secure Projects require at least one nonsecure callable function in order to build (Remove this if it is not required to build). */
BSP_CMSE_NONSECURE_ENTRY void template_nonsecure_callable ()
{

}
#endif
